//
//  Database Engine Wrapper
//  Copyright  1994, 1995
//  B. W. Bush
//  All rights reserved
//
//  $Revision: 2.0 $
//  $RCSfile: EXAMPLE1.CPP $
//  $Date: 1995/07/14 16:17:34 $


// Table Creation Example


#include <iostream.h>

#include <string.h>

#include <dew.h>


int main()
{
    // Start the engine.

    TDEWEngine engine;

    // Open a database.

    TDEWDatabase database;

    // Try to create the table "DEW_TEST.DB".

    try {

        // Make first field ten characters long called "Name", the second field a date called "Date", and the third field a number called "Amount".

        TDEWFldDesc fields[3];
        fields[0] = TDEWFldDesc(1, "Name", fldZSTRING, 0, 10);
        fields[1] = TDEWFldDesc(2, "Date", fldDATE);
        fields[2] = TDEWFldDesc(3, "Amount", fldFLOAT);

        // Make "Name" + "Date" the primary key.

        DBIKEY keyFld;
        keyFld[0] = 1;
        keyFld[1] = 2;
        TDEWIdxDesc index(keyFld, 2, NULL, 0, NULL, TRUE);

        // Make the table have three fields and one index.

        TDEWCrTblDesc descriptor("DEW_TEST.DB", 3, fields, 1, &index);

        // Create the table.

        database.CreateTable(descriptor);

        cout << "Table \"DEW_TEST.DB\" creation succeeded." << endl;

    } catch(const TDEWException& exception) {

        // Report an error creating the table.

        cerr << "Table \"DEW_TEST.DB\" creation failed: " << exception << endl;

    }

    return 0;
}