//
//  Database Engine Wrapper
//  Copyright  1994, 1995
//  B. W. Bush
//  All rights reserved
//
//  $Revision: 2.0 $
//  $RCSfile: EXAMPLE5.CPP $
//  $Date: 1995/07/14 16:17:34 $


// Key Search Example


#include <iostream.h>

#include <string.h>

#include <dew.h>


int main()
{
    // Start the engine.

    TDEWEngine engine;

    // Open a database.

    TDEWDatabase database;

   // Try to search for a key value in "DEW_TEST.DB".

    try {

        // Create a cursor for the table and find its record buffer.

        TDEWCursor cursor(database, "DEW_TEST.DB");
        TDEWRecord& record = cursor.Record();

        // Create a record buffer for the key.

        TDEWKey key(cursor);
        TDEWRecord keyRecord(cursor);
        keyRecord.PutField("Name", "Bruce");
        cursor.ExtractKey(key, keyRecord);

        // Search for the key.

        cout << "Searching for (\"Bruce\", *, *) . . ." << endl;
        cursor.GetRecordForKey(key, 1);
        string name;
        TDate date;
        float amount;
        record.GetField("Name", name);
        record.GetField("Date", date);
        record.GetField("Amount", amount);
        #ifdef __BCPLUSPLUS__
            date.SetPrintOption(TDate::Numbers);
        #endif
        cout << "\t(\"" << name << "\", " << date << ", " << amount << ")" << endl;

        cout << "Search successfully completed." << endl;

    } catch(const TDEWException& exception) {

        // Report a failure of the search.

        cerr << endl << "Key could not be found: " << exception << endl;

    }

    return 0;
}