//
//  Database Engine Wrapper
//  Copyright  1994, 1995
//  B. W. Bush
//  All rights reserved
//
//  $Revision: 2.0 $
//  $RCSfile: EXAMPLE6.CPP $
//  $Date: 1995/07/14 16:14:06 $


// Book Mark Example


#include <iostream.h>

#include <string.h>

#include <dew.h>


int main()
{
    // Start the engine.

    TDEWEngine engine;

    // Open a database.

    TDEWDatabase database;

   // Try to set and retrieve a bookmark in "DEW_TEST.DB".

    try {

        // Create a cursor for the table and find its record buffer.

        TDEWCursor cursor(database, "DEW_TEST.DB");
        TDEWRecord& record = cursor.Record();

        // Create a bookmark.

        TDEWBookMark bookMark(cursor);

        cursor.Advance();
        cursor.Advance();

        string name;
        record.GetField("Name", name);
        cout << "Setting book mark at \"" << name << "\"" << endl;
        cursor.GetBookMark(bookMark);

        // Go to the book mark.

        cursor.SetToBegin();
        cout << "Moving to book mark . . . \"";
        cursor.SetToBookMark(bookMark);
        string name2;
        record.GetField("Name", name2);
        cout << name2 << "\"" << endl;

        cout << "Bookmark successfully found." << endl;

    } catch(const TDEWException& exception) {

        // Report a failure of the search.

        cerr << endl << "Bookmark could not be found: " << exception << endl;

    }

    return 0;
}
