//
//  Database Engine Wrapper
//  Copyright  1994, 1995
//  B. W. Bush
//  All rights reserved
//
//  $Revision: 2.0 $
//  $RCSfile: BLOB.H $
//  $Date: 1995/07/14 16:15:34 $


#ifndef BWB_DEW_BLOB
#define BWB_DEW_BLOB


// TDEWBlob class.

class DEWCLASSPREFIX TDEWBlob
{
  public:

    TDEWBlob();
    TDEWBlob(TDEWRecord&, const UINT16, const DBIOpenMode = dbiREADWRITE);
    TDEWBlob(TDEWRecord&, const string&, const DBIOpenMode = dbiREADWRITE);
    ~TDEWBlob();

    void Close();
    UINT32 Get(const UINT32, const UINT32, const pBYTE) const;
    void GetHeading(const pBYTE) const;
    void Open(TDEWRecord&, const UINT16, const DBIOpenMode = dbiREADWRITE);
    void Open(TDEWRecord&, const string&, const DBIOpenMode = dbiREADWRITE);
    void Put(const UINT32, const UINT32, const pcBYTE);
    UINT32 Size() const;
    void Truncate(const UINT32);

  private:

    TDEWBlob(const TDEWBlob&) : fBuffer(0), fHCursor(NULL) {}

    TDEWBlob& operator=(const TDEWBlob&) {if (fBuffer != 0) Close(); return *this;}

    pBYTE fBuffer;
    UINT16 fField;
    hDBICur fHCursor;
};


#endif // BWB_DEW_BLOB
