//
//  Database Engine Wrapper
//  Copyright  1994, 1995
//  B. W. Bush
//  All rights reserved
//
//  $Revision: 2.0 $
//  $RCSfile: DATABASE.H $
//  $Date: 1995/07/14 16:15:34 $


#ifndef BWB_DEW_DATABASE
#define BWB_DEW_DATABASE


// TDEWDatabase class.

class DEWCLASSPREFIX TDEWDatabase
  : public MDEWObject
{
  public:

    TDEWDatabase(const pcCHAR = NULL, const pcCHAR = NULL, const DBIOpenMode = dbiREADWRITE, const DBIShareMode = dbiOPENSHARED, const pcCHAR = NULL, const UINT16 = NULL, const pcFLDDesc = NULL, const pcBYTE = NULL);
    ~TDEWDatabase();

    void AcqPersistTableLock(const pcCHAR, const pcCHAR = NULL);
    void AddIndex(const pcCHAR, const pcCHAR, const IDXDesc&, const pcCHAR = NULL);
    void Close();
    void CopyTable(const pcCHAR, const pcCHAR, const pcCHAR = NULL, const BOOL = TRUE);
    void CreateTable(const CRTblDesc&, const BOOL = TRUE);
    void DeleteIndex(const pcCHAR, const pcCHAR, const UINT16 = NULL, const pcCHAR = NULL, const pcCHAR = NULL);
    void DeleteTable(const pcCHAR, const pcCHAR = NULL);
    string Directory(const BOOL = FALSE) const;
    void DoRestructure(const UINT16, const pcCRTblDesc, const pcCHAR, const pcCHAR = NULL, const pcCHAR = NULL, const BOOL = FALSE);
    void EmptyTable(const pcCHAR, const pcCHAR = NULL);
    TDEWCursor FamilyList(const pcCHAR, const pcCHAR = NULL);
    TDEWCursor FieldList(const pcCHAR, const pcCHAR = NULL, const BOOL = FALSE);
    TDEWCursor FileList(const pcCHAR);
    string FullName(const pcCHAR, const pcCHAR = NULL) const;
    hDBIDb Handle() const {return fHDatabase;}
    TDEWCursor IndexList(const pcCHAR, const pcCHAR = NULL);
    TDEWCursor InMemTable(const pcCHAR, const UINT16, const pcFLDDesc);
    void Open(const pcCHAR = NULL, const pcCHAR = NULL, const DBIOpenMode = dbiREADWRITE, const DBIShareMode = dbiOPENSHARED, const pcCHAR = NULL, const UINT16 = NULL, const pcFLDDesc = NULL, const pcBYTE = NULL);
    void PackTable(const pcCHAR, const pcCHAR = NULL, const BOOL = TRUE);
    TDEWCursor Query(const pcCHAR, const DBIQryLang = qrylangSQL);
    void RegenIndex(const pcCHAR, const pcCHAR, const UINT16 = NULL, const pcCHAR = NULL, const pcCHAR = NULL);
    void RelPersistTableLock(const pcCHAR, const pcCHAR = NULL);
    void RenameTable(const pcCHAR, const pcCHAR, const pcCHAR = NULL);
    TDEWCursor RintList(const pcCHAR, const pcCHAR = NULL);
    TDEWCursor SecurityList(const pcCHAR, const pcCHAR = NULL);
    void SetDirectory(const pcCHAR);
    void Sort(const pcCHAR, const UINT16, const pcUINT16, const pcCHAR = NULL, const pcCHAR = NULL, const pcBOOL = NULL, const pcSORTOrder = NULL, pfSORTCompFn* = NULL, const BOOL = FALSE);
    TDEWCursor TableList(const BOOL = FALSE, const BOOL = FALSE, const pcCHAR = NULL);
    UINT16 TableOpenCount(const pcCHAR, const pcCHAR = NULL) const;
    TDEWCursor TempTable(const CRTblDesc&);
    TDEWCursor VchkList(const pcCHAR, const pcCHAR = NULL);

  private:

    TDEWDatabase(const TDEWDatabase&) : fHDatabase(NULL) {}

    TDEWDatabase& operator=(const TDEWDatabase&) {if (IsOpen()) Close(); return *this;}

    hDBIDb fHDatabase;
};


#endif // BWB_DEW_DATABASE
