//
//  Database Engine Wrapper
//  Copyright  1994, 1995
//  B. W. Bush
//  All rights reserved
//
//  $Revision: 2.0 $
//  $RCSfile: ENGINE.H $
//  $Date: 1995/07/14 16:15:34 $


#ifndef BWB_DEW_ENGINE
#define BWB_DEW_ENGINE


// TDEWEngine class.

class DEWCLASSPREFIX TDEWEngine
{
  public:

    TDEWEngine(const pcDBIEnv = NULL);
    ~TDEWEngine();

    void AddPassword(const pcCHAR);
    TDEWCursor CfgInfoList(const pcCHAR = NULL, const DBIOpenMode = dbiREADONLY, const CFGMode = cfgPersistent) const; 
    void CheckRefresh() const;
    void Close();
    TDEWCursor DatabaseList() const;
    const FMTDate& DateFormat() const;
    void DebugLayerOptions(const UINT16, const pcCHAR = NULL);
    TDEWCursor DriverList() const;
    void DropPassword(const pcCHAR);
    TDEWCursor FieldTypesList(const pcCHAR, const pcCHAR = NULL) const;
    void GetCallBack(const CBType, UINT32&, UINT16&, pVOID&, pfDBICallBack&) const;
    void GetClientInfo(CLIENTInfo&) const;
    void GetDatabaseDesc(const pcCHAR, DBDesc&) const;
    void GetDriverDesc(const pcCHAR, DRVType&) const;
    void GetFieldTypeDesc(const pcCHAR, const pcCHAR, const pcCHAR, FLDType&) const;
    void GetIndexTypeDesc(const pcCHAR, const pcCHAR, IDXType&) const;
    void GetSesInfo(SESInfo&) const;
    void GetSysConfig(SYSConfig&) const;
    void GetSysInfo(SYSInfo&) const;
    void GetSysVersion(SYSVersion&) const;
    void GetTableTypeDesc(const pcCHAR, const pcCHAR, TBLType&) const;
    TDEWCursor IndexTypesList(const pcCHAR) const;
    TDEWCursor LdList() const;
    string LdName(const pcCHAR, const pcCHAR) const;
    void LoadDriver(const pcCHAR);
    string NetUserName() const;
    const FMTNumber& NumberFormat() const;
    void Open(const pcDBIEnv = NULL);
    void RegisterCallBack(const CBType, const UINT32, const UINT16, const pVOID, const pfDBICallBack);
    void SetCurrSession(TDEWSession&);
    void SetDateFormat(const FMTDate&);
    void SetLockRetry(const INT16);
    void SetNumberFormat(const FMTNumber&);
    void SetPrivateDir(const pcCHAR = NULL);
    void SetTimeFormat(const FMTTime&);
    TDEWCursor TableTypesList(const pcCHAR);
    const FMTTime& TimeFormat() const;
    void UseIdleTime();
    TDEWCursor UserList() const;

  private:

    TDEWEngine(const TDEWEngine&) {};

    TDEWEngine& operator=(const TDEWEngine&) {return *this;}

    FMTDate fFmtDate;
    FMTTime fFmtTime;
    FMTNumber fFmtNumber;
};


#endif // BWB_DEW_ENGINE
