//
//  Database Engine Wrapper
//  Copyright  1994
//  B. W. Bush
//  All rights reserved
//
//  $Revision: 2.0 $
//  $RCSfile: CSTRING.H $
//  $Date: 1995/07/14 16:15:34 $


#ifndef BWB_DEW_STRING
#define BWB_DEW_STRING


#include <iostream.h>

#include <string.h>


// Minimal implementation of the ANSI C++ standard string class.

class string
{
  public:

    string(const char* s = "")
      : fBuffer(NULL)
    {
        fBuffer = new char[strlen(s) + 1];
        strcpy(fBuffer, s);
    }
    string(const string& s)
      : fBuffer(NULL)
    {
        fBuffer = new char[strlen(s.fBuffer) + 1];
        strcpy(fBuffer, s.fBuffer);
    }
    ~string()
    {
        delete fBuffer;
    }
    string& operator=(const string& s)
    {
        char* const copy = new char[strlen(s.fBuffer) + 1];
        strcpy(copy, s.fBuffer);
        delete fBuffer;
        fBuffer = copy;
        return *this;
    }
    const char* c_str() const
    {
        return fBuffer;
    }
    size_t length() const
    {
        return strlen(fBuffer);
    }
    int operator==(const string& s) const
    {
        return strcmp(fBuffer, s.fBuffer) == 0;
    }

  private:

    char* fBuffer;
};

inline ostream& operator<<(ostream& os, const string& s)
{
    os << s.c_str();

    return os;
}


#endif // BWB_DEW_STRING
