//
//  Database Engine Wrapper
//  Copyright  1994
//  B. W. Bush
//  All rights reserved
//
//  $Revision: 2.0 $
//  $RCSfile: DATETIME.H $
//  $Date: 1995/07/14 16:15:34 $


#ifndef BWB_DEW_DATETIME
#define BWB_DEW_DATETIME


#include <dos.h>


// TDEWDate class.

class TDEWDate
  : private date
{
  public:

    TDEWDate()
    {
        getdate(this);
    }
    TDEWDate(unsigned day, unsigned month, unsigned year)
    {
        da_day = day;
        da_mon = month;
        da_year = year;
    }
    unsigned Month() const
    {
        return da_mon;
    }
    unsigned DayOfMonth() const
    {
        return da_day;
    }
    unsigned Year() const
    {
        return da_year;
    }
};

inline ostream& operator<<(ostream& os, const TDEWDate& date)
{
    os << date.Month() << "/" << date.DayOfMonth() << "/" << date.Year();

    return os;
}


// TDEWTime class.

class TDEWTime
  : private time
{
  public:

    TDEWTime()
    {
        gettime(this);
    }
    TDEWTime(unsigned hour, unsigned minute, unsigned second)
    {
        ti_hour = hour;
        ti_min = minute;
        ti_sec = second;
        ti_hund = 0;
    }
    unsigned Hour() const
    {
        return ti_hour;
    }
    unsigned Minute() const
    {
        return ti_min;
    }
    unsigned Second() const
    {
        return ti_sec;
    }
};

inline ostream& operator<<(ostream& os, const TDEWTime& time)
{
    os << time.Hour() << ":" << time.Minute() << ":" << time.Second();

    return os;
}


#endif // BWB_DEW_DATETIME
