//
//  Database Engine Wrapper
//  Copyright  1994, 1995
//  B. W. Bush
//  All rights reserved
//
//  $Revision: 2.0 $
//  $RCSfile: STRUCT.H $
//  $Date: 1995/07/14 16:14:29 $


#ifndef BWB_DEW_STRUCT
#define BWB_DEW_STRUCT


// Struct for defining the environ.

class TDEWEnv
  : public DBIEnv
{
  public:

    TDEWEnv();
    TDEWEnv(const DBIEnv&);
    TDEWEnv(const pcCHAR = NULL, const pcCHAR = NULL, const BOOL = FALSE, const pcCHAR = NULL, const pcCHAR = NULL);
};


// Field Descriptor.

class TDEWFldDesc
  : public FLDDesc
{
  public:

    TDEWFldDesc();
    TDEWFldDesc(const FLDDesc&);
    TDEWFldDesc(const UINT16, const pcCHAR, const UINT16, const UINT16 = 0, const INT16 = 1, const INT16 = 0);
};


// Index description.

class TDEWIdxDesc
  : public IDXDesc
{
  public:

    TDEWIdxDesc();
    TDEWIdxDesc(const IDXDesc&);
    TDEWIdxDesc(const DBIKEY, const UINT16, const pcCHAR, const UINT16 = 0, const pcCHAR = NULL, const BOOL = FALSE, const BOOL = FALSE, const BOOL = FALSE, const BOOL = TRUE, const BOOL = FALSE, const BOOL = FALSE, const pcCHAR = NULL, const UINT16 = 2048);
    TDEWIdxDesc(const pcCHAR, const UINT16, const pcCHAR, const UINT16 = 0, const pcCHAR = NULL, const BOOL = FALSE, const BOOL = FALSE, const BOOL = FALSE, const BOOL = TRUE, const BOOL = FALSE, const BOOL = FALSE, const pcCHAR = NULL, const UINT16 = 2048);
};


// Val Check structure.

class TDEWVchkDesc
  : public VCHKDesc
{
  public:

    TDEWVchkDesc();
    TDEWVchkDesc(const VCHKDesc&);
    TDEWVchkDesc(const UINT16);

    void SetRequired();
    void SetMinVal(const pcBYTE);
    void SetMinValToday();
    void SetMaxVal(const pcBYTE);
    void SetMaxValToday();
    void SetDefVal(const pcBYTE);
    void SetDefValToday();
    void SetPict(const pcCHAR);
    void SetLkup(const LKUPType, const pcCHAR);
};


// Ref Integrity Desc.

class TDEWRintDesc
  : public RINTDesc
{
  public:

    TDEWRintDesc();
    TDEWRintDesc(const RINTDesc&);
    TDEWRintDesc(const UINT16, const pcCHAR, const pcCHAR, const DBIKEY, const DBIKEY, const UINT16, const RINTQual = rintCASCADE, const RINTQual = rintCASCADE, const RINTType = rintDEPENDENT);
};


// Security description.

class TDEWSecDesc
  : public SECDesc
{
  public:

    TDEWSecDesc();
    TDEWSecDesc(const SECDesc&);
    TDEWSecDesc(const UINT16, const PRVType[DBIMAXFLDSINSEC], const pcCHAR, const PRVType = prvNONE, const UINT16 = NOFAMRIGHTS);
};


// Create/Restruct Table descr.

class TDEWCrTblDesc
  : public CRTblDesc
{
  public:

    TDEWCrTblDesc();
    TDEWCrTblDesc(const CRTblDesc&);
    TDEWCrTblDesc(const pcCHAR, const UINT16, const pcFLDDesc, const UINT16 = 0, const pcIDXDesc = NULL, const UINT16 = 0, const pcVCHKDesc = NULL, const UINT16 = 0, const pcRINTDesc = NULL, const UINT16 = 0, const pcSECDesc = NULL, const pcCHAR = NULL, const pcCHAR = NULL);
};


#endif // BWB_DEW_STRUCT
