//
//  Database Engine Wrapper
//  Copyright  1994, 1995
//  B. W. Bush
//  All rights reserved
//
//  $Revision: 2.0 $
//  $RCSfile: SESSION.CPP $
//  $Date: 1995/07/14 16:17:34 $


// Definitions.

#include <dew.h>        // database engine wrapper


// Constructor.

TDEWSession::TDEWSession(const pcCHAR pszName, const pcCHAR pNetDir)
  : fHSession(NULL)
{
    Open(pszName, pNetDir);
}


TDEWSession::TDEWSession(TDEWEngine&)
  : fHSession(NULL)
{
    TDEWException::CheckResult(DbiGetCurrSession(&fHSession));
}


// Destructor.

TDEWSession::~TDEWSession()
{
    if (IsOpen())
        Close();
}


// Close session.

void TDEWSession::Close()
{
    TDEWException::CheckResult(DbiCloseSession(fHSession));
    fHSession = NULL;
}


// Open session.

void TDEWSession::Open(const pcCHAR pszName, const pcCHAR pNetDir)
{
    if (IsOpen())
        Close();

    TDEWException::CheckResult(DbiStartSession((pCHAR) pszName, &fHSession, (pCHAR) pNetDir));
}

void TDEWSession::Open(TDEWEngine&)
{
    if (IsOpen())
        Close();

    TDEWException::CheckResult(DbiGetCurrSession(&fHSession));
}
